function sdkp:CHAT_MSG_LOOT(event, arg1)
	-- in the case of a manually assigned loot, the event will be the reason/note
	if not self:IsTrackLoot() then 
		return;
	end
	local _, _, player, link = string.find(arg1, "([^%s]+) receives loot: (.+)%.");
	if player == nil then
		player = UnitName("player");
		_, _, link = string.find(arg1, "You receive loot: (.+)%.");
		if not link then
			return;
		end
	end
	link = link:trim();
	
	local _, _, color, _, item = string.find(link, "|c(%x+)|Hitem:(%d+)[:%d%-]+|h%[(.-)%]|h|r");	
	local amount = self:GetDkpForItem(item);
	local bids = self.db.profile.bids;
	if bids and bids[player:lower()] then 
		amount = bids[player:lower()];
	end
	
	if (self:GetLootFilter(nil, SDKP_ICOLORS[color])) and (not self:IsIgnoreLoot(item)) then
		local main = self:GetAltInfo(player);
		if main then player = main;	end
		self:EnqueueDialog(
			"How much did |c00ffff00" .. player .. "|r spend on\n" .. link .. "?",
			"Ok", 
			"Cancel", 
			function (cost)
				sdkp:RecordPurchase(player, link, cost, event);
			end,
			function()end,
			amount
		); 
		self:ConfirmPopup();
	end
end

function sdkp:PLAYER_REGEN_ENABLED(event)
	self:ConfirmPopup();
end

function sdkp:CHAT_MSG_WHISPER(event, text, from, ...)
	local _, _, wCmd, wCmdArgs = text:find("^(![^%s]+)%s*(.*)");
	if wCmd then 
		wCmd = wCmd:lower();
		if wCmd == "!bid" then
			self:WCmdBid(from, wCmdArgs);
		elseif wCmd == "!help" then
			self:WCmdHelp(from);
		elseif wCmd == "!here" then
			self:WCmdHere(from);
		elseif wCmd == "!dkp" then
			self:WCmdDKP(from, wCmdArgs);
		elseif wCmd == "!attendance" or wCmd == "!att" then
			self:WCmdAttn(from, wCmdArgs);
		end
	end
end

function sdkp:LOOT_OPENED(event, ...)
	if self:IsTrackLoot() then 
		local loot_target = UnitName("target");
		if SDKP_RAID_ZONE[GetRealZoneText()] then 
			self.LOOT_WINDOW = {};
			local i;
			for i = 1, GetNumLootItems() do
		 		if LootSlotIsItem(i) then
		   			local link = GetLootSlotLink(i);
		   			local _, _, color, item = string.find(link, "|c(%x+)|Hitem[:%d%-]+|h%[(.-)%]|h|r");
					if (self:GetLootFilter(nil, SDKP_ICOLORS[color])) and (not self:IsIgnoreLoot(item)) then
						self.LOOT_WINDOW[link]=link;
					end
		 		end
		   	end
		   	local english_boss = self.bb[loot_target];
		   	if english_boss then
				self:CmdSnapshot(info, SDKP_UNIT_TO_ENCOUNTER[english_boss] or english_boss, self.LOOT_WINDOW);	
			end
	   	end
	end
end

function sdkp:ZONE_CHANGED_NEW_AREA(event, ...)
	local zone = GetRealZoneText();
	if not SDKP_RAID_ZONE[zone] and self:IsTrackLoot(nil) and not UnitIsDeadOrGhost("player") then 
		self:Debug("Turning off loot tracking since we are leaving the instance.");
		self:ToggleTrackLoot(nil, false); -- 
	elseif SDKP_RAID_ZONE[zone] and not(self:IsTrackLoot(nil) or self.db.profile.was_ghost) then
		self:Debug("Entering instance, but not after a ghost run... track loot is off... turn on?");
		self:EnqueueDialog(
			"|cffff7d0aSDKP|r\nWould you like to turn loot tracking on?",
			"Yes", 
			"No", 
			function ()
				sdkp:ToggleTrackLoot(nil, true);
			end
		);
		self:ConfirmPopup();
	end
	self.db.profile.was_ghost = UnitIsDeadOrGhost("player");
end